import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.utils"

import "SandBox.Crafters"

crafters = CraftersWindow()

newcharwin = NewCharWindow()

charwin = {}

shopwin = ShopWindow()

crafters.newcharbut.Click = function( sender, args ) newcharwin:SetVisible( true )  end
newcharwin.SaveBut.Click = function( sender, args ) newcharwin:SaveChar( crafters ) gsave() end

crafters.chars = Turbine.PluginData.Load( Turbine.DataScope.Server, "SandboxCrafters" )

if crafters.chars ~= nil then 
    for i in pairs(crafters.chars) do
        crafters:MakeBut( crafters.chars[i] )
    end
else
    crafters.chars = {}
end
function crafters.Closed( sender, args ) 
    gsave()
end

CraftersCommand = Turbine.ShellCommand()
function CraftersCommand:Execute( command, args )
    crafters:SetVisible( true )
end

Turbine.Shell.AddCommand( "Craft", CraftersCommand )

function gsave( )
    Turbine.PluginData.Save( Turbine.DataScope.Server, "SandboxCrafters", crafters.chars )
end

function loadchar( data )
    charwin[data.name] = CharWindow()
    --charwin[data.name]:Clear()
    charwin[data.name].data = data
    charwin[data.name]:SetText( data.name )
    charwin[data.name].prof1:SetText( data.prof1 )
    charwin[data.name].prof1s:SetText( data.prof1s )
    charwin[data.name].prof1m:SetText( data.prof1m )
    charwin[data.name].prof2:SetText( data.prof2 )
    charwin[data.name].prof2s:SetText( data.prof2s )
    charwin[data.name].prof2m:SetText( data.prof2m )
    charwin[data.name].prof3:SetText( data.prof3 )
    charwin[data.name].prof3s:SetText( data.prof3s )
    charwin[data.name].prof3m:SetText( data.prof3m )
    charwin[data.name].shopwin = ShopWindow()
    charwin[data.name].shopwin:SetText( data.name .. "'s Shopping list" )
    charwin[data.name].shopwin.slist:SetText( data.shoplist )

    charwin[data.name].dbut.Click = function( sender, args ) deletechar( data ) end
    charwin[data.name].shopbut.Click = function( sender, args ) charwin[data.name].shopwin:SetVisible( true ) end

    charwin[data.name].prof1win = RecipeWindow()
    charwin[data.name].prof1win:SetText( data.name .. "'s " .. data.prof1 .. " recipes." )
    charwin[data.name].prof1r.Click = function( sender, args ) 
        if data.prof1rec ~= nil then
            charwin[data.name].prof1win.recipes = data.prof1rec
            for i in pairs( data.prof1rec ) do
                charwin[data.name].prof1win:BuildItem( data.prof1rec[i] )
            end
        end
        charwin[data.name].prof1win:SetVisible( true ) 
    end
    charwin[data.name].prof1win.Closed = function( sender, args ) savechar(data)  gsave() end

    charwin[data.name].prof2win = RecipeWindow()
    charwin[data.name].prof2win:SetText( data.name .. "'s " .. data.prof2 .. " recipes." )
    charwin[data.name].prof2r.Click = function( sender, args )
        if data.prof2rec ~= nil then
            charwin[data.name].prof2win.recipes = data.prof2rec
            for i in pairs( data.prof2rec ) do
                charwin[data.name].prof2win:BuildItem( data.prof2rec[i] )
            end
        end
        charwin[data.name].prof2win:SetVisible( true ) 
    end
    charwin[data.name].prof2win.Closed = function( sender, args ) savechar(data)  gsave() end


    charwin[data.name].prof3win = RecipeWindow()
    charwin[data.name].prof3win:SetText( data.name .. "'s " .. data.prof3 .. " recipes." )
    charwin[data.name].prof3r.Click = function( sender, args )
        if data.prof3rec ~= nil then
            charwin[data.name].prof3win.recipes = data.prof3rec
            for i in pairs( data.prof3rec ) do
                charwin[data.name].prof3win:BuildItem( data.prof3rec[i] )
            end
        end
        charwin[data.name].prof3win:SetVisible( true ) 
    end
    charwin[data.name].prof3win.Closed = function( sender, args ) savechar(data)  gsave() end
    
    charwin[data.name].sbut.Click = function( sender, args )
        savechar( data )
        --charwin[data.name].shopwin:Clear()
        charwin[data.name].prof1win:SetVisible( false )
        charwin[data.name].prof2win:SetVisible( false )
        charwin[data.name].prof3win:SetVisible( false )
        --charwin[data.name]:Clear()
        charwin[data.name]:SetVisible( false ) 
        gsave() 
    end

    charwin[data.name]:SetVisible( true )
    charwin[data.name].Closed = function( sender, args )
        savechar( data )
        gsave( )
        charwin[data.name].shopwin:SetVisible( false )
        charwin[data.name].prof1win:SetVisible( false )
        charwin[data.name].prof1win.newrecwin:SetVisible( false )
        charwin[data.name].prof2win:SetVisible( false )
        charwin[data.name].prof2win.newrecwin:SetVisible( false )
        charwin[data.name].prof3win:SetVisible( false )
        charwin[data.name].prof3win.newrecwin:SetVisible( false )
    end 
end

function  savechar( data )
    charwin[data.name].data.name = charwin[data.name]:GetText()
    charwin[data.name].data.prof1 = charwin[data.name].prof1:GetText()
    charwin[data.name].data.prof1s = charwin[data.name].prof1s:GetText()
    charwin[data.name].data.prof1m = charwin[data.name].prof1m:GetText()
    charwin[data.name].data.prof2 = charwin[data.name].prof2:GetText()
    charwin[data.name].data.prof2s = charwin[data.name].prof2s:GetText()
    charwin[data.name].data.prof2m = charwin[data.name].prof2m:GetText()
    charwin[data.name].data.prof3 = charwin[data.name].prof3:GetText()
    charwin[data.name].data.prof3s = charwin[data.name].prof3s:GetText()
    charwin[data.name].data.prof3m = charwin[data.name].prof3m:GetText()
    charwin[data.name].data.shoplist = charwin[data.name].shopwin.slist:GetText()
    charwin[data.name].data.prof1rec = charwin[data.name].prof1win.recipes
    charwin[data.name].data.prof2rec = charwin[data.name].prof2win.recipes
    charwin[data.name].data.prof3rec = charwin[data.name].prof3win.recipes
    --charwin[data.name].shopwin:Clear()
    gsave()
end

function deletechar( data )
    --D Turbine.Shell.WriteLine( "Deleting charicter: " .. data.name )
    charwin[data.name]:SetVisible( false )
    crafters.listbox:RemoveItemAt( data.index )
    crafters.chars[data.name] = nil
    gsave()
end

Turbine.Shell.WriteLine( "Loaded Crafters version 0.8.03" )
Turbine.Shell.WriteLine( "Type /Craft to bring up the window." )
